//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2023. Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.IO;

using Hiperscan.Unix;
using Hiperscan.GtkExtensions.StandardDialogs;
using Hiperscan.Extensions.ReferenceCheck.Control.GuiUpdate;

namespace Hiperscan.Extensions.ReferenceCheck.View
{
    public class ZipFileOpenDialog
    {
        public static void Run(Gtk.Window parent_window, UpdateArgs args)
        {
            ZipFileOpenDialog tmp = new ZipFileOpenDialog(parent_window, args);
        }

        private ZipFileOpenDialog(Gtk.Window parent_window, UpdateArgs args)
        {
            Gtk.FileChooserDialog chooser = new Gtk.FileChooserDialog(Catalog.GetString("Select reference check file:"),
                                                                      parent_window,
                                                                      Gtk.FileChooserAction.Open,
                                                                      Gtk.Stock.Open,
                                                                      Gtk.ResponseType.Ok,
                                                                      Gtk.Stock.Cancel,
                                                                      Gtk.ResponseType.Cancel);

            if (false == FileIO.ExistsDirectory(args.DialogArgs.FileName))
                chooser.SetCurrentFolder(Environment.GetFolderPath(Environment.SpecialFolder.Desktop));
            else
                chooser.SetCurrentFolder(args.DialogArgs.FileName);

            Gtk.FileFilter file_filter = new Gtk.FileFilter();
            file_filter.Name = Catalog.GetString("zip Archive");
            file_filter.AddPattern("*.zip");
            chooser.AddFilter(file_filter);
            chooser.SelectMultiple = false;

            args.DialogArgs.Response = StandardDialog.Convert((Gtk.ResponseType)chooser.Run());
            args.DialogArgs.FileName = chooser.Filename;

            chooser.Destroy();
        }
    }
}
